"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var osReleaseDetector = require("./os-release-detector");
var imageIdDetector = require("./image-id-detector");
var apkAnalyzer = require("./apk-analyzer");
var aptAnalyzer = require("./apt-analyzer");
var rpmAnalyzer = require("./rpm-analyzer");
function analyze(targetImage) {
    return Promise.all([
        imageIdDetector.detect(targetImage),
        osReleaseDetector.detect(targetImage),
        Promise.all([
            apkAnalyzer.analyze(targetImage),
            aptAnalyzer.analyze(targetImage),
            rpmAnalyzer.analyze(targetImage),
        ]),
    ])
        .then(function (res) { return ({
        imageId: res[0],
        osRelease: res[1],
        results: res[2],
    }); });
}
exports.analyze = analyze;
//# sourceMappingURL=index.js.map