"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var subProcess = require("./sub-process");
var Docker = /** @class */ (function () {
    function Docker(targetImage) {
        this.targetImage = targetImage;
    }
    Docker.prototype.run = function (cmd, args) {
        if (args === void 0) { args = []; }
        return subProcess.execute('docker', [
            'run', '--rm', '--entrypoint', '""', '--network', 'none',
            this.targetImage, cmd
        ].concat(args));
    };
    Docker.prototype.catSafe = function (filename) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var stderr_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.run('cat', [filename])];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        stderr_1 = _a.sent();
                        if (typeof stderr_1 === 'string' && stderr_1.indexOf('No such file') >= 0) {
                            return [2 /*return*/, ''];
                        }
                        throw new Error(stderr_1);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Docker;
}());
exports.Docker = Docker;
//# sourceMappingURL=docker.js.map